(function() {
  var ABBrowserComm;
  var __slice = Array.prototype.slice, __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  ABBrowserComm = (function() {
    function ABBrowserComm(opt) {
      if (opt == null) {
        opt = {};
      }
      this.name = opt.name || "js";
      this.nextId = 1;
      this.outbox = [];
      this.callbacks = {};
      if (window.appborg) {
        throw new Error("You may create at most one ABBrowserComm instance");
      }
      window.appborg = this;
    }
    ABBrowserComm.prototype.send = function() {
      var args, callback, dicts, e, id, info, method, opt, x, _i, _len;
      method = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      callback = null;
      dicts = [];
      for (_i = 0, _len = args.length; _i < _len; _i++) {
        x = args[_i];
        if ((typeof x) === 'function') {
          callback = x;
        } else {
          dicts.push(x);
        }
      }
      info = {};
      opt = {};
      if (dicts.length === 1) {
        info = dicts[0];
      } else if (dicts.length === 2) {
        opt = dicts[0], info = dicts[1];
      }
      id = this.nextId;
      this.nextId++;
      if (callback) {
        this.callbacks[id] = callback;
      }
      e = {
        id: id,
        from: this.name,
        to: opt.to || "subprocess",
        method: method,
        info: info
      };
      this.outbox.push(e);
      return this.emit('send', e);
    };
    ABBrowserComm.prototype.pushAndPullEvents = function(events) {
      var json;
      this.pushEvents(events);
      json = JSON.stringify(this.outbox);
      this.outbox = [];
      return json;
    };
    ABBrowserComm.prototype.pushEvents = function(events) {
      var callback, e, error, f, _i, _j, _len, _len2, _ref, _results;
      _results = [];
      for (_i = 0, _len = events.length; _i < _len; _i++) {
        e = events[_i];
        if ((e.result || e.error) && e.id) {
          callback = this.callbacks[e.id];
          if (callback) {
            try {
              callback(e.error || null, e.result || {});
            } catch (exc) {
              1;
            }
          }
          delete this.callbacks[e.id];
        } else if (e.method) {
          _ref = this.listeners(e.method);
          for (_j = 0, _len2 = _ref.length; _j < _len2; _j++) {
            f = _ref[_j];
            if (f.length < 2) {
              try {
                f(e.info);
                this._respond(e, null, {});
              } catch (exc) {
                error = {
                  message: exc.toString()
                };
                if (window.printStackTrace) {
                  error.stacktrace = printStackTrace({
                    e: exc
                  });
                }
                this._respond(e, error, null);
              }
            } else {
              f(e.info, __bind(function(error, result) {
                if (error == null) {
                  error = null;
                }
                if (result == null) {
                  result = {};
                }
                return this._respond(e, error, result);
              }, this));
            }
          }
        }
        _results.push(this.emit('receive', e));
      }
      return _results;
    };
    ABBrowserComm.prototype._respond = function(e, error, result) {
      var response;
      response = {
        id: e.id,
        from: this.name,
        to: e.from
      };
      if (error) {
        response.error = error;
        response.result = null;
      } else {
        response.error = null;
        response.result = result;
      }
      return this.outbox.push(response);
    };
    ABBrowserComm.prototype._initEventEmitter = function() {
      if (!this.EventEmitter_listeners) {
        return this.EventEmitter_listeners = {};
      }
    };
    ABBrowserComm.prototype.on = function(k, f) {
      var arr;
      this._initEventEmitter();
      arr = this.EventEmitter_listeners[k] = this.EventEmitter_listeners[k] || [];
      return arr.push(f);
    };
    ABBrowserComm.prototype.listeners = function(k) {
      this._initEventEmitter();
      if (!this.EventEmitter_listeners[k]) {
        this.EventEmitter_listeners[k] = [];
      }
      return this.EventEmitter_listeners[k];
    };
    ABBrowserComm.prototype.emit = function() {
      var args, arr, f, k, _i, _len, _results;
      k = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      this._initEventEmitter();
      arr = this.EventEmitter_listeners[k] = this.EventEmitter_listeners[k] || [];
      _results = [];
      for (_i = 0, _len = arr.length; _i < _len; _i++) {
        f = arr[_i];
        _results.push(f.apply(null, args));
      }
      return _results;
    };
    return ABBrowserComm;
  })();
  module.exports = {
    ABBrowserComm: ABBrowserComm
  };
}).call(this);
